From 0d67c58d52d6d1302bdd6c49bfdaf85c58abaf2d Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jun 09 2015 00:41:04 +0000
Subject: [PATCH 105/254] Bugfixes.


---

diff --git a/hubs/consumer.py b/hubs/consumer.py
index 1515966..3cb4fc8 100644
--- a/hubs/consumer.py
+++ b/hubs/consumer.py
@@ -46,7 +46,7 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
         self.checks_by_username = collections.defaultdict(list)
 
         widgets = session.query(hubs.models.Widget).all()
-        log.info("Comparing message against %i widgets" % len(widgets))
+        log.info("Building lookup from  %i total widgets" % len(widgets))
         for widget in widgets:
             check = widget.module.should_invalidate
 
@@ -59,7 +59,8 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
             for category in check.hints['categories']:
                 self.checks_by_category[category].append((check, widget,))
 
-            for username in check.hints['usernames_function']:
+            usernames = check.hints['usernames_function'](widget)
+            for username in usernames:
                 self.checks_by_username[username].append((check, widget,))
 
     @property
@@ -99,16 +100,16 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
 
         # Start this by finding a subset of widget checks that might match this
         # message. Look them up based on the hints they declare.
-        checks = \
-            set(self.checks_by_topic[topic]) + \
-            set(self.checks_by_category[category])
+        checks = set(
+            self.checks_by_topic[topic] + self.checks_by_category[category]
+        )
         log.info("Found %i checks to try for this message" % len(checks))
 
         # Then, with that hopefully smaller list of checks, try them all and
         # see if any tell us that we should nuke various data caches.
         for check, widget in checks:
             if check(msg, session, widget):
-                log.info("Invalidating cache for %r" % widget)
+                log.info("! Invalidating cache for %r" % widget)
                 # Invalidate the cache...
                 invalidate_cache(widget.module, **widget.config)
                 # Rebuild it.
diff --git a/hubs/hinting.py b/hubs/hinting.py
index 9f049f3..b04d688 100644
--- a/hubs/hinting.py
+++ b/hubs/hinting.py
@@ -1,4 +1,3 @@
-import collections
 import decorator
 
 import fedmsg.config
@@ -22,7 +21,7 @@ def hint(topics=None, categories=None, usernames=None):
         wrapped.hints = dict(
             topics=topics,
             categories=categories,
-            username_function=usernames,
+            usernames_function=usernames,
         )
         return wrapped
 
diff --git a/hubs/widgets/sticky.py b/hubs/widgets/sticky.py
index 36d4a1a..885108d 100644
--- a/hubs/widgets/sticky.py
+++ b/hubs/widgets/sticky.py
@@ -1,3 +1,4 @@
+from hubs.hinting import hint, prefixed as _
 from hubs.widgets.chrome import panel
 from hubs.widgets.base import argument
 
@@ -17,6 +18,7 @@ def data(session, widget, text):
     return dict(text=text)
 
 
+@hint(topics=[_('hubs.widget.update')])
 def should_invalidate(message, session, widget):
     if message['topic'].endswith('hubs.widget.update'):
         if message['msg']['widget']['id'] == widget.id:

